import { createRouter, createWebHashHistory } from "vue-router";
//import Home from "../views/Home.vue";
import ProfilUser from "../views/ProfilUser.vue";
import ProfilAdmin from "../views/ProfilAdmin.vue";
import ChangePass from "../views/ChangePass.vue";
import Login from "../views/Login.vue";
import UserIndex from "../views/UserIndex.vue";
import AdminIndex from "../views/AdminIndex.vue";
import KaryawanInsert from "../views/KaryawanInsert.vue";
import DepartemenIndex from "../views/DepartemenIndex.vue";
import KaryawanEdit from "../views/KaryawanEdit.vue";
import KaryawanDetail from "../views/KaryawanDetail.vue";
import AdminInsert from "../views/AdminInsert.vue";
import AdminEdit from "../views/AdminEdit.vue";
import KpiIndex from "../views/KpiIndex.vue";
import KpiDetail from "../views/KpiDetail.vue";
import KpiCreate from "../views/KpiCreate.vue";
import KpiManagerDetail from "../views/KpiManagerDetail.vue";
import NotFound from "../views/NotFound.vue";
import ManagerKpiIndex from "../views/ManagerKpiIndex.vue";
import ManagerKaryawanIndex from "../views/ManagerKaryawanIndex.vue";
import ManagerKaryawanDetail from "../views/ManagerKaryawanDetail.vue";
import ResponseIndex from "../views/ResponseIndex.vue";
import ResponseDetail from "../views/ResponseDetail.vue";
import ResponseEmployee from "../views/ResponseEmployee.vue";
import { HTTP } from '../http-common'

const adminRoute = ['Login', 'profil-admin', 'change-pass', 'User', 'Admin', 'KaryawanInsert', 'Departemen', 'KaryawanEdit', 'KaryawanDetail', 'AdminInsert', 'AdminEdit']
const empRoute = ['Login', 'profil-user', 'change-pass', 'kpiIndex', 'KpiDetail', 'KpiResponses', 'ResponseEmployee', 'KpiCreate', 'KpiManagerDetail', 'ManagerkpiIndex', 'ManagerkaryawanIndex', 'ManagerKaryawanDetail', 'ResponseIndex', 'ResponseDetail']

const routes = [
  {
    path: "/",
    redirect: "/login"
  },
  {
    path: "/login",
    name: "Login",
    component: Login,
  },
  {
    path: "/profil-user/:user_id",
    name: "profil-user",
    component: ProfilUser,
  },
  {
    path: "/profil-admin/:id",
    name: "profil-admin",
    component: ProfilAdmin,
  },
  {
    path: "/change-pass",
    name: "change-pass",
    component: ChangePass,
  },
  {
    path: "/user",
    name: "User",
    component: UserIndex,
  },
  {
    path: "/admin",
    name: "Admin",
    component: AdminIndex,
  },
  {
    path: "/user/insert",
    name: "KaryawanInsert",
    component: KaryawanInsert,
  },
  {
    path: "/departemen",
    name: "Departemen",
    component: DepartemenIndex,
  },
  {
    path: "/user/edit/:id",
    name: "KaryawanEdit",
    component: KaryawanEdit,
  },
  {
    path: "/user/:id",
    name: "KaryawanDetail",
    component: KaryawanDetail,
  },
  {
    path: "/admin/insert",
    name: "AdminInsert",
    component: AdminInsert,
  },
  {
    path: "/admin/edit/:id",
    name: "AdminEdit",
    component: AdminEdit,
  },
  {
    path: "/kpi",
    name: "kpiIndex",
    component: KpiIndex,
  },
  {
    path: "/kpi/:id",
    name: "KpiDetail",
    component: KpiDetail,
  },
  {
    path: "/kpi/:kpiId/responses",
    name: "KpiResponses",
    component: ResponseIndex,
    props: { isManager: false }
  },
  {
    path: "/kpi/:kpiId/responses/:responseId",
    name: "ResponseEmployee",
    component: ResponseEmployee,
  },
  {
    path: "/manager/kpi/create",
    name: "KpiCreate",
    component: KpiCreate,
  },
  {
    path: "/manager/kpi/:id",
    name: "KpiManagerDetail",
    component: KpiManagerDetail,
  },
  {
    path: "/manager/kpi",
    name: "ManagerkpiIndex",
    component: ManagerKpiIndex,
  },
  {
    path: "/manager/employees",
    name: "ManagerkaryawanIndex",
    component: ManagerKaryawanIndex,
  },
  {
    path: "/manager/employees/:id",
    name: "ManagerKaryawanDetail",
    component: ManagerKaryawanDetail,
  },
  {
    path: "/manager/kpi/:kpiId/employees/:empId/responses",
    name: "ResponseIndex",
    component: ResponseIndex,
    props: { isManager: true }
  },
  {
    path: "/manager/kpi/:kpiId/employees/:empId/responses/:responseId",
    name: "ResponseDetail",
    component: ResponseDetail
  },
  {
    path: "/:catchAll(.*)",
    name: "NotFound",
    component: NotFound,
  },
];

const router = createRouter({
  // history: createWebHistory(process.env.BASE_URL),
  history: createWebHashHistory(),
  routes,
});

router.beforeEach((to,from, next)=>{
  if (to.name != "Login" && to.name != "NotFound"){
    HTTP.get("users/profile").then((res)=>{
      let isAdmin = res.data.data.is_admin
      if (isAdmin){
        if (adminRoute.includes(to.name)){
          next()
        }else{
          next("/forbidden")
        }
      }else{
        if (empRoute.includes(to.name)){
          next()
        }else{
          next("/forbidden")
        }
      }
    }).catch(()=>{
      next("/login")
    })
  }else if (to.name != "NotFound"){
    HTTP.get("users/profile").then((res)=>{
      if (res.data.data.is_admin){
        next("/user")
      }else{
        next("/kpi")
      }
    }).catch(()=>{
      next()
    })
  }else{
    next()
  }
  
})

export default router;
